CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  cols = 80
  rows = 64
  tiles = cols * rows

  spacetile = $220

  nuchars = 7
  dmask = $0000_07FF
  spiDO     = 0
  spiClk    = 1
  spiDI     = 2
  spiCS     = 3

  #1, up_left, up_right, low_left, low_right, v_bar, h_bar, quote               'user characters

OBJ

  fsrw  : "fsrwFemto"                 ' FAT File System Read/Write
  vga     : "VGA_1280x1024_Tile_Driver_With_Cursor"
  mouse   : "mouse"
'  key     : "keyboard"

VAR
  long ioControl[2]

  long  col, row, color
  long  boxcolor, boxptr

  long  array[tiles/2]
  long  cursor[1+32]

  long  cursor_x, cursor_y, cursor_col, cursor_def

  long  user_charbase

  
PUB kiosk | hover, old_hover, old_box, btext, otext, btw, otw, bpress
  'start mouse and set bound parameters
  mouse.start(24, 25)
  mouse.bound_limits(0, 0, 0, 1279, 1023, 0)
  mouse.bound_scales(1, 1, 0)
  mouse.bound_preset(640, 512, 0)

  fsrw.start(@ioControl)                        ' Start I2C/SPI driver

  'start vga tile driver
  vga.start(16, @array, @vgacolors, @cursor_x, 0, 0)

  '64 byte align the user characters
  longmove(uchar & $FFFF_FC00,uchar,CONSTANT(64*nuchars))

  user_charbase := (@uchar >> 6)

  print($100)

  
  print_string(string("               Welcome to the Parallax Propeller Demo Kiosk"))
  print($0D)
  print($0D)
  print_string(string("Please choose from one of the following demos:"))
  print($0D)
  print($0D)
  print_string(string("         TV Graphics")) 'DEMOA.BIN
  print($0D)
  print($0D)
  print_string(string("        VGA Graphics")) 'DEMOB.BIN
  print($0D)
  print($0D)
  print_string(string("   Propeller 3D wire")) 'DEMOC.BIN
  print($0D)
  print($0D)
  print_string(string("   Vocal Spatializer")) 'DEMOD.BIN  +
  print($0D)
  print($0D)
  print_string(string("       Singing Monks")) 'DEMOE.BIN
  print($0D)
  print($0D)
  print_string(string("        Speech Synth")) 'DEMOF.BIN  *
  print($0D)
  print($0D)
  print_string(string("  Hydra Sound System")) 'DEMOG.BIN  *
  print($0D)
  print($0D)
  print_string(string("      Logic Analyser")) 'DEMOH.BIN
  print($0D)
  print($0D)
  print_string(string("                Life")) 'DEMOI.BIN
  print($0D)
  print($0D)
  print_string(string("   Basic Interpreter")) 'DEMOJ.BIN
  print($0D)
  print($0D)
  print_string(string("   Microphone to VGA")) 'DEMOK.BIN  
  print($0D)
  print($0D)
  print_string(string("        Sand Physics")) 'DEMOL.BIN
  print($0D)
  print($0D)
  print_string(string("                Pong")) 'DEMOM.BIN  
  print($0D)
  print($0D)
  'draw_box
  
  quote_box(22,7,35,@text1)
  cursor_def := 0
  cursor_col := $A8
  old_box := 1
  repeat
    cursor_x := mouse.bound_x
    cursor_y := mouse.bound_y
    if cursor_x < 320
      case cursor_y
        96..128: hover := 13
        160..192: hover := 12
        224..256: hover := 11
        288..320: hover := 10
        352..384: hover := 9
        416..448: hover := 8
        480..512: hover := 7
        544..576: hover := 6
        608..640: hover := 5
        672..704: hover := 4
        736..768: hover := 3
        800..832: hover := 2
        864..896: hover := 1
        
        OTHER: hover := 0
    else
      hover := 0
    if hover <> old_hover
      if old_hover
        unhighlight(old_hover)
      if hover
        highlight(hover)
        otw := lookup(old_box: 37, 42, 43, 40, 33, 37, 35, 22, 30, 40, 46, 46, 45)
        'otext := lookup(old_box: text1, text2, text3, text4, text5, text6, text7, text8, text9, text10, text11, text12, text13) 
        erase_area(21, old_box << 2 + 3, otw, 6{byte[otext]+2})
        btw := lookup(hover: 35, 40, 41, 38, 31, 35, 33, 20, 28, 38, 44, 44, 43)
        btext := lookup(hover: @text1, @text2, @text3, @text4, @text5, @text6, @text7, @text8, @text9, @text10, @text11, @text12, @text13)         
        quote_box(22,hover << 2 + 3, btw, btext)
        old_box := hover 
      old_hover := hover
    if hover AND mouse.buttons == 1
      bpress := true
    if hover AND (mouse.buttons & 1 == 0) AND bpress
      byte[@dfile+4] := $40 + hover
      'print_string(@dfile)
      'waitcnt(clkfreq<<3 + cnt)
      if {\}fsrw.mount(spiDO,spiClk,spiDI,spiCS) < 0
        print_string(string("Can't mount SD card"))'abort string("Can't mount SD card")
      if {\}fsrw.popen(@dfile,"r")
        print_string(string("Can't open file"))'abort string("Can't open file")
      fsrw.bootSDCard
      bpress := false


PRI highlight(line) | i 
  repeat i from 1 to 19
    array.word[(line << 2 + 4) * cols + i] := array.word[(line << 2 + 4) * cols + i] & dmask + 2 << 11
    array.word[(line << 2 + 5) * cols + i] := (array.word[(line << 2 + 5) * cols + i] & dmask) | 1 + 2 << 11


PRI unhighlight(line) | i
  repeat i from 1 to 19
    array.word[(line << 2 + 4) * cols + i] := array.word[(line << 2 + 4) * cols + i] & dmask   
    array.word[(line << 2 + 5) * cols + i] := (array.word[(line << 2 + 5) * cols + i] & dmask) | 1 

PRI print_multiline(x, y, width, str)| n, i, j, l
  n := byte[str]
  row := y
  col := x
  repeat i from 1 to n
    l := width  
    repeat while byte[str]
      print(byte[str++])
      l--
    repeat j from 1 to l
      print($20)
    row := y + i<<1
    col := x
    str++
  row := y
  col := x + width - 1
  print(" ")
  
  'array.word[x*cols + y + width - 1] := $230 + 1 << 10
       
PRI erase_area(left, top, width, height) | i, j
  color := 0
  repeat j from 0 to height
    row := top + j
    col := left
    repeat i from 0 to width
      print(" ")
      
PRI quote_box(left, top, width, mstr) | height, x, y, i

' Draw a box

  boxcolor := 23 '$10 + clr
  color := 1 'clr + 5

  'width := 40'strsize(str)
  height := byte[mstr] << 1

  boxptr := top * cols + left
  qboxchr(1)
  repeat i from 1 to width
    qboxchr(6)
  qboxchr(3)
  repeat i from 1 to height
    boxptr := (top + i) * cols + left
    qboxchr(5)
    boxptr += width
    boxcolor++
    qboxchr(5)
    boxcolor--
  boxptr := (top + height + 1) * cols + left
  qboxchr(2)
  boxcolor++
  repeat i from 1 to width
    qboxchr(6)
  boxcolor--
  qboxchr(4)
  boxptr := (top + 1 )* cols + left - 1
  qboxchr(9)
  qboxchr(7)
  boxptr := (top + 2)*cols + left - 1
  qboxchr(10)
  qboxchr(8)

  col := left + 1
  row := top + 1
  print_multiline(left+1, top+1, width, mstr)
  

PRI qboxchr(c)

  array.word[boxptr++] := user_charbase + c + boxcolor << 10


PRI draw_hat(x,y) | i

    
PRI print_string(ptr)

  repeat while byte[ptr]
    print(byte[ptr++])
    

PRI print(c) | i, k

'' Print a character
''
''       $0D = new line
''  $20..$FF = character
''      $100 = clear screen
''      $101 = home
''      $108 = backspace
''$110..$11F = select color

  case c
    $0D:                'return?
      newline

    $20..$FF:           'character?
      k := color << 1 + c & 1
      i := $200 + (c & $FE) + k << 10
      array.word[row * cols + col] := i
      array.word[(row + 1) * cols + col] := i | 1
      if ++col == cols
        newline

    $100:               'clear screen?
      wordfill(@array, spacetile, tiles)
      col := row := 0

    $101:               'home?
      col := row := 0

    $108:               'backspace?
      if col
        col--

    $110..$11F:         'select color?
      color := c & $F

PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    print("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      print(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      print("0")
    i /= 10

PRI newline | i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
      wordmove(@array.word[i*cols], @array.word[(i+2)*cols], cols)
    'clear new line
    wordfill(@array.word[(rows-2)*cols], spacetile, cols<<1)


DAT
vgacolors long

  long $3C143C14       'lt grey on dk grey
  long $3C3C1414
  long $50F450F4        'cream/blue
  long $5050F4F4
  long $143C143C
  long $14143C3C
  long $0C000C00       'blue
  long $0C0C0000
  long $FC00FC00       'white
  long $FCFC0000
  long $FF80FF80       'red/white
  long $FFFF8080
  long $FF20FF20       'green/white
  long $FFFF2020
  long $FF28FF28       'cyan/white
  long $FFFF2828
  long $C0408080       'redbox
  long $3010F020       'greenbox
  long $3C142828       'cyanbox
  long $FC54A8A8       'greybox
  long $3C14FF28       'cyanbox+underscore
  long $F030C050       'graphics colors
  long $881430FC
  long $00F4D014       '23
  long $0000D0F4
  long $04F404F4        'cream/blue
  long $0404F4F4
  long $BC000400        'quote box darkblue outside, black border, cream inside
  long $0400BC00        'inverse for right and bottom bars
  
padding LONG  0[11] 'alignment padding for the following user defined characters     
uchar   'upper left rounded   
        {LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000}
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        

        LONG  %%1110_0000_0000_0000
        LONG  %%1111_0000_0000_0000
        LONG  %%1111_1000_0000_0000
        LONG  %%1111_1110_0000_0000
        LONG  %%2211_1111_0000_0000
        LONG  %%2222_1111_0000_0000
        LONG  %%2222_2111_1000_0000
        LONG  %%2222_2211_1100_0000

        LONG  %%2222_2211_1100_0000
{        LONG  %%2222_2211_1100_0000
        
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000}
        'lower left rounded    
{        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000}

        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1130_0000
        LONG  %%2222_2211_1130_0000
        LONG  %%2222_2111_1330_0000
        LONG  %%2222_1111_3330_0000
        LONG  %%2211_1111_3330_0000
        LONG  %%1111_1113_3330_0000
        LONG  %%1111_1333_3330_0000

        
        LONG  %%1111_3333_3330_0000
        LONG  %%1113_3333_3300_0000
        LONG  %%3333_3333_3300_0000
        LONG  %%3333_3333_3000_0000
        LONG  %%3333_3333_0000_0000
        LONG  %%3333_3333_0000_0000
        LONG  %%3333_3330_0000_0000
        LONG  %%3333_3000_0000_0000
        
        LONG  %%3333_0000_0000_0000
        LONG  %%3330_0000_0000_0000
{        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000}
        'upper right rounded   
{        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000}
{        LONG  %%0000_0000_0000_0000
        
        LONG  %%0000_0000_0000_0000}
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0003_3333_3111
        LONG  %%0000_0033_3333_1111
        
        LONG  %%0000_0333_3331_1111
        LONG  %%0003_3333_3111_1111
        LONG  %%0033_3333_1111_1122
        LONG  %%0033_3333_1111_2222
        LONG  %%0333_3331_1112_2222
        LONG  %%0333_3331_1112_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222

        LONG  %%3333_3311_1122_2222
{        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        'lower right rounded   
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3311_1122_2222

        LONG  %%3333_3311_1122_2222}
        LONG  %%3333_3311_1122_2222
        LONG  %%3333_3331_1112_2222
        LONG  %%3333_3331_1112_2222
        LONG  %%0333_3333_1111_2222
        LONG  %%0333_3333_1111_1122
        LONG  %%0033_3333_3111_1111
        LONG  %%0033_3333_3331_1111
        
        LONG  %%0003_3333_3333_1111
        LONG  %%0003_3333_3333_3111
        LONG  %%0000_3333_3333_3333
        LONG  %%0000_0333_3333_3333
        LONG  %%0000_0033_3333_3333
        LONG  %%0000_0003_3333_3333
        LONG  %%0000_0000_3333_3333

        LONG  %%0000_0000_0333_3333
        LONG  %%0000_0000_0003_3333
        LONG  %%0000_0000_0000_0333
{        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
}        'left/right bar        
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
                            
{        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        LONG  %%2222_2211_1100_0000
        'top/bottom bar        
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000

        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
}        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000

        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%1111_1111_1111_1111
        LONG  %%1111_1111_1111_1111

        LONG  %%1111_1111_1111_1111
        LONG  %%1111_1111_1111_1111
        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222

        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222
{        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222
        LONG  %%2222_2222_2222_2222}
        'quote
        LONG  %%2222_2211_1100_0000'0000_0000_0000_0000
        LONG  %%2222_2211_1100_0000'0000_0000_0000_0000
        LONG  %%2222_2211_1100_0000'0000_0000_0000_0000
        LONG  %%2222_2211_1111_0000'0000_0000_0000_0000
        LONG  %%2222_2222_1111_1100'0000_0000_0000_0000
        LONG  %%2222_2222_2211_1111'0000_0000_0000_0000
        LONG  %%2222_2222_2222_1111'1100_0000_0000_0000
        LONG  %%2222_2222_2222_2211'1111_0000_0000_0000
        LONG  %%2222_2222_2222_2222'1111_1100_0000_0000
        LONG  %%2222_2222_2222_2222'2211_1111_0000_0000
        LONG  %%2222_2222_2222_2222'2222_1111_1100_0000
        LONG  %%2222_2222_2222_2222'2222_2211_1111_0000
        LONG  %%2222_2222_2222_2222'2222_2222_1111_1000
        LONG  %%2222_2222_2222_2222'2222_2222_2211_1100
        LONG  %%2222_2222_2222_2222'2222_2222_2222_1110
        LONG  %%2222_2222_2222_2222'2222_2222_2222_2111        
        LONG  %%2222_2222_2222_2222'2222_2222_2222_2111
        LONG  %%2222_2222_2222_2222'2222_2222_2222_1110
        LONG  %%2222_2222_2222_2222'2222_2222_2211_1100
        LONG  %%2222_2222_2222_2222'2222_2222_1111_1000
        LONG  %%2222_2222_2222_2222'2222_2211_1111_0000
        LONG  %%2222_2222_2222_2222'2222_1111_1100_0000
        LONG  %%2222_2222_2222_2222'2211_1111_0000_0000
        LONG  %%2222_2222_2222_2222'1111_1100_0000_0000
        LONG  %%2222_2222_2222_2211'1111_0000_0000_0000
        LONG  %%2222_2222_2222_1111'1100_0000_0000_0000
        LONG  %%2222_2222_2211_1111'0000_0000_0000_0000
        LONG  %%2222_2222_1111_1133'0000_0000_0000_0000
        LONG  %%2222_2211_1111_3333'0000_0000_0000_0000
        LONG  %%2222_2211_1133_3333'0000_0000_0000_0000
        LONG  %%2222_2211_1133_3333'0000_0000_0000_0000
        LONG  %%2222_2211_1133_3300'0000_0000_0000_0000
{       }
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%1100_0000_0000_0000
        LONG  %%1111_0000_0000_0000
        LONG  %%1111_1100_0000_0000
        LONG  %%2211_1111_0000_0000
        LONG  %%2222_1111_1100_0000
        LONG  %%2222_2211_1111_0000
        LONG  %%2222_2222_1111_1000
        LONG  %%2222_2222_2211_1100
        LONG  %%2222_2222_2222_1110
        LONG  %%2222_2222_2222_2111
        LONG  %%2222_2222_2222_2111
        LONG  %%2222_2222_2222_1113
        LONG  %%2222_2222_2211_1133
        LONG  %%2222_2222_1111_1333
        LONG  %%2222_2211_1111_3333
        LONG  %%2222_1111_1133_3330
        LONG  %%2211_1111_3333_3300
        LONG  %%1111_1133_3333_3000
        LONG  %%1111_3333_3333_0000
        LONG  %%1133_3333_3300_0000
        LONG  %%3333_3333_0000_0000   
        LONG  %%3333_3300_0000_0000
        LONG  %%3333_0000_0000_0000
        LONG  %%3300_0000_0000_0000
        LONG  %%0000_0000_0000_0000
        LONG  %%0000_0000_0000_0000

PHat    'a2 0
        LONG  %%0000000000000000[13]
        LONG  %%1100000000000000
        LONG  %%1110000000000000
        LONG  %%1111000000000000
        'a3 1
        LONG  %%0000000000000000[5]
        LONG  %%1110000000000000
        LONG  %%1111100000000000
        LONG  %%1111111000000000
        LONG  %%2211111110000000
        LONG  %%2221111111100000
        LONG  %%2222211111111000
        LONG  %%2222221111111110
        LONG  %%2222222111111111
        LONG  %%2222222211111111
        LONG  %%2222222221111111
        LONG  %%2222222222111111
        'a4 2
        LONG  %%0000000000000000
        LONG  %%1111111000000000
        LONG  %%2222221111000000
        LONG  %%2222222222111000
        LONG  %%2222222222211111
        LONG  %%3222222222222111
        LONG  %%3322222222222221
        LONG  %%3332222222222222[2]
        LONG  %%3333222222222222
        LONG  %%3333322222222222[2]
        LONG  %%3333332222222222[2]
        LONG  %%3333333222222222[2]
        'a5 3
        LONG  %%0001111111111000
        LONG  %%1113333333333111
        LONG  %%2233333333333322
        LONG  %%2333333333333332
        LONG  %%3333333333333333[12]
        'a6 4
        LONG  %%0000000000000000
        LONG  %%0000000001111111
        LONG  %%0000001111222222
        LONG  %%0001111222222222
        LONG  %%1111122222222222
        LONG  %%1112222222222223
        LONG  %%1222222222222233
        LONG  %%2222222222222333[2]
        LONG  %%2222222222223333
        LONG  %%2222222222233333[2]
        LONG  %%2222222222333333[2]
        LONG  %%2222222223333333[2]
        'a7 5
        LONG  %%0000000000000000[5]
        LONG  %%0000000000000111
        LONG  %%0000000000011111
        LONG  %%0000000001111111
        LONG  %%0000000111111122
        LONG  %%0000011111111222
        LONG  %%0001111111122222
        LONG  %%0111111111222222
        LONG  %%1111111112222222
        LONG  %%1111111122222222
        LONG  %%1111111222222222
        LONG  %%1111112222222222
        'a8 6
        LONG  %%0000000000000000[13]
        LONG  %%0000000000000011
        LONG  %%0000000000000111
        LONG  %%0000000000001111
        'b1 7
        LONG  %%0000000000000000[12]
        LONG  %%1000000000000000
        LONG  %%1100000000000000
        LONG  %%1110000000000000
        LONG  %%1110000000000000
        'b2 8
        LONG  %%1111100000000000
        LONG  %%1111110000000000
        LONG  %%1111111100000000
        LONG  %%1111111110000000
        LONG  %%1111111111000000
        LONG  %%1111111111100000
        LONG  %%1111111111110000
        LONG  %%2111111111111000
        LONG  %%2211111111111100[2]
        LONG  %%2221111111111110
        LONG  %%2222111111111111[2]
        LONG  %%2222211111111111[2]
        LONG  %%2222221111111111
        'b3 9
        LONG  %%2222222222211111
        LONG  %%2222222222221111
        LONG  %%2222222222222111
        LONG  %%2222222222222211
        LONG  %%2222222222222221
        LONG  %%2222222222222222[11]
        'b4 10
        LONG  %%3333333322222222[3]
        LONG  %%3333333332222222[3]
        LONG  %%3333333333222222[3]
        LONG  %%3333333333322222[4]
        LONG  %%3333333333332222[3]
        'b6 11
        LONG  %%2222222233333333[3]
        LONG  %%2222222333333333[3]
        LONG  %%2222223333333333[3]
        LONG  %%2222233333333333[4]
        LONG  %%2222333333333333[3]
        'b7 12
        LONG  %%1111122222222222
        LONG  %%1111222222222222
        LONG  %%1112222222222222
        LONG  %%1122222222222222
        LONG  %%1222222222222222
        LONG  %%2222222222222222[11]
        'b8 13
        LONG  %%0000000000011111
        LONG  %%0000000000111111
        LONG  %%0000000011111111
        LONG  %%0000000111111111
        LONG  %%0000001111111111
        LONG  %%0000011111111111
        LONG  %%0000111111111111
        LONG  %%0001111111111112
        LONG  %%0011111111111122
        LONG  %%0011111111111122
        LONG  %%0111111111111222
        LONG  %%1111111111112222[2]
        LONG  %%1111111111122222[2]
        LONG  %%1111111111222222
        'b9 14
        LONG  %%0000000000000000[12]        
        LONG  %%0000000000000001
        LONG  %%0000000000000011
        LONG  %%0000000000000111
        LONG  %%0000000000000111
        'c1 15
        LONG  %%1111000000000000
        LONG  %%1111100000000000[2]
        LONG  %%1111110000000000[2]
        LONG  %%1111111000000000[2]
        LONG  %%1111111100000000[2]
        LONG  %%1111111110000000[2]
        LONG  %%1111111111000000[2]
        LONG  %%1111111111100000[3]
        'c2 16
        LONG  %%2222221111111111
        LONG  %%2222222111111111[2]
        LONG  %%2222222211111111[2]
        LONG  %%2222222221111111[2]
        LONG  %%2222222222111111[4]
        LONG  %%2222222222211111[4]
        LONG  %%2222222222221111
        'c4 17
        LONG  %%3333333333332222[2]
        LONG  %%3333333333333222[6]
        LONG  %%3333333333333322[8]
        'c6 18
        LONG  %%2222333333333333[2]
        LONG  %%2223333333333333[6]
        LONG  %%2233333333333333[8]
        'c8 19
        LONG  %%1111111111222222
        LONG  %%1111111112222222[2]
        LONG  %%1111111122222222[2]
        LONG  %%1111111222222222[2]
        LONG  %%1111112222222222[4]
        LONG  %%1111122222222222[4]
        LONG  %%1111222222222222
        'c9 20
        LONG  %%0000000000001111
        LONG  %%0000000000011111[2]
        LONG  %%0000000000111111[2]
        LONG  %%0000000001111111[2]
        LONG  %%0000000011111111[2]
        LONG  %%0000000111111111[2]
        LONG  %%0000001111111111[2]
        LONG  %%0000011111111111[3]
        'd1 21
        LONG  %%1111111111110000[3]
        LONG  %%1111111111111000[3]
        LONG  %%1111111111111100[3]
        LONG  %%1111111111111110[7]
        'd2 22
        LONG  %%2222222222221111[3]
        LONG  %%2222222222222111[8]
        LONG  %%2222222222222211[3]
        LONG  %%1122222222222211
        LONG  %%1111111111111211
        'd3 23
        LONG  %%2222222222222222[13]
        LONG  %%2222222222222211
        LONG  %%1111111111111111[2]
        'd4 24
        LONG  %%3333333333333322
        LONG  %%3333333333333332[12]
        LONG  %%1111111111111111[3]
        'd5 25
        LONG  %%3333333333333333[13]
        LONG  %%1111111111111111[3]
        'd6 26
        LONG  %%2233333333333333
        LONG  %%2333333333333333[12]
        LONG  %%1111111111111111[3]
        'd7 27
        LONG  %%2222222222222222[13]
        LONG  %%1122222222222222
        LONG  %%1111111111111111[2]
        'd8 28
        LONG  %%1111222222222222[3]
        LONG  %%1112222222222222[8]
        LONG  %%1122222222222222[3]
        LONG  %%1122222222222211
        LONG  %%1121111111111111
        'd9 29
        LONG  %%0000111111111111[3]
        LONG  %%0001111111111111[3]
        LONG  %%0011111111111111[3]
        LONG  %%0111111111111111[7]
        'e1 30
        LONG  %%1111111111111110[3]
        LONG  %%1111111111111111
        LONG  %%2222111111111111
        LONG  %%2222222222111111[2]
        LONG  %%2222111111111111
        LONG  %%1111111111111110
        LONG  %%1111111111110000
        LONG  %%1111111111000000
        LONG  %%1111000000000000
        LONG  %%0000000000000000[4]
        'e2 31
        LONG  %%1111111111111111[2]
        LONG  %%2211111111111111
        LONG  %%2222222222222111
        LONG  %%2222222222222222[4]
        LONG  %%2222222222222111
        LONG  %%2211111111111111
        LONG  %%1111111111111111[2]
        LONG  %%1111111111111000
        LONG  %%1100000000000000
        LONG  %%0000000000000000[2]
        'e3 32
        LONG  %%1111111111111111
        LONG  %%2211111111111111
        LONG  %%2222222222222222[8]
        LONG  %%2211111111111111
        LONG  %%1111111111111111[3]
        LONG  %%1100000000000000
        LONG  %%0000000000000000
        'e456 33
        LONG  %%1111111111111111
        LONG  %%2222222222222222[10]
        LONG  %%1111111111111111[4]
        LONG  %%0000000000000000
        'e7 34
        LONG  %%1111111111111111
        LONG  %%1111111111111122
        LONG  %%2222222222222222[8]
        LONG  %%1111111111111122
        LONG  %%1111111111111111[3]
        LONG  %%0000000000000011
        LONG  %%0000000000000000        
        'e8 35
        LONG  %%1111111111111111[2]
        LONG  %%1111111111111122
        LONG  %%1112222222222222
        LONG  %%2222222222222222[4]
        LONG  %%1112222222222222
        LONG  %%1111111111111122
        LONG  %%1111111111111111[2]
        LONG  %%0001111111111111
        LONG  %%0000000000000011
        LONG  %%0000000000000000
        'e9 36
        LONG  %%0111111111111111[3]
        LONG  %%1111111111111111
        LONG  %%1111111111112222
        LONG  %%1111112222222222[2]
        LONG  %%1111111111112222
        LONG  %%0111111111111111
        LONG  %%0001111111111111
        LONG  %%0000001111111111
        LONG  %%0000000000001111
        LONG  %%0000000000000000[4]




text1  byte 3,"Demonstrates broadcast television",0,"graphics capabilities.",0,"Author: Chip Gracey",0
text2  byte 2,"Demonstrates VGA graphics capabilities",0,"Author: Chip Gracey",0
text3  byte 2,"3D wireframe rotation of Propeller logo",0,"Author: Beau Schwabe",0 
text4  byte 2,"Three dimensional placement of voice",0,"Author: Chip Gracey",0
text5  byte 2,"Monestary Quartet in 3D space",0,"Author: Chip Gracey",0
text6  byte 2,"Speech Synthesis Object", 0,"Author: Chip Gracey, Phil Pilgram",0
text7  byte 2,"Wavetable and ADPCM Synthesizer",0, "Author: Andrew Arsenault", 0
text8  byte 2,"Logic Analyser", 0, "Author: Paul Baker",0
text9  byte 2,"John Conway's Game of Life", 0, "Author: TalleyKen", 0
text10 byte 2,"FemptoBasic for Propeller", 0, "Author: Mike Green", 0
text11 byte 2,"Demonstrates use of counter to perform ADC", 0, "Author: Chip Gracey",0
text12 byte 2,"Realtime modeling of 10,000 grains of sand", 0, "Author: Dennis Ferron", 0
text13 byte 2,"Very difficult version of the old classic", 0, "Author: AC Fishing", 0

dfile  byte "DEMOX.BIN", 0, 0
                